Subject: bug#32252: [PATCH] %o and %x now format signed numbers

From: Eli Zaretskii <[email-masked]>
Date: Wed, 25 Jul 2018 17:17:26 +0300

> Cc: [email-masked]
> From: Paul Eggert <[email-masked]>
> Date: Tue, 24 Jul 2018 17:54:57 -0700
> 
> Eli Zaretskii wrote:
> 
> > Do we really need to have identical or consistent behavior for fixnums
> > and bignums?  They are different beasts, so the behavior could be
> > different, provided that it makes sense for each of the varieties.
> 
> I don't know what inconsistent behavior would make sense here. There's a 
> longstanding tradition in Lisp that integer arithmetic just works, and I don't 
> see why Emacs would want to fight against that tradition here. Although there 
> may be some low-level functions that distinguish between fixnums and bignums for 
> efficiency reasons, the vast majority of Lisp functions should not distinguish 
> them, and 'format' should be one of those functions.

I agree that this would be nice to have, but I'm not sure we should
absolutely require that, at least not yet.  Not before we have enough
experience to be sure we have good reasons for changing long-standing
behavior.

> Although I understand the concern about the patch, the concern doesn't seem to 
> be warranted, and any compatibility issues can easily be addressed by setting 
> binary-as-signed.

Well, we've seen such movies in the past, and we know we've been wrong
in at least some cases.